#include "mdp.h"

#ifdef MT_FREEGLUT
#  include "opengl.h"

void showMaze(){
  byteA &maze=global_maze;
  byteA img(maze.d0,maze.d1,3);
  uint x,y,dx=maze.d1,dy=maze.d0;
  for(x=0;x<dx;x++) for(y=0;y<dy;y++){
    if(maze(y,x)==0){ img(y,x,0)=255; img(y,x,1)=255; img(y,x,2)=255; }
    else if(maze(y,x)==1){ img(y,x,0)=0;   img(y,x,1)=0;   img(y,x,2)=0;   }
    else if(maze(y,x)==2){ img(y,x,0)=255; img(y,x,1)=0;   img(y,x,2)=0;   }
    else if(maze(y,x)==3){ img(y,x,0)=0;   img(y,x,1)=255; img(y,x,2)=0;   }
    else if(maze(y,x)==4){ img(y,x,0)=0;   img(y,x,1)=0;   img(y,x,2)=255; }
    else HALT("strange global maze");
  }
  OpenGL gl;
  glWatchImage(img,true,10);
}

void plotPolicyAndValue(const arr& pi,const arr& V,const MDP& mdp,bool wait){
  plotOpengl();
  plotModule.colors=false;
  //plotModule.grid=true;
  
  //glDisplayRedBlue(V,global_maze.d0,global_maze.d1,false);
  arr tmp;
  uintA tmpI;
  plotClear();
  tmp=~V;
  tmp *= .8/tmp.max();
  tmp.reshape(global_maze.d0,global_maze.d1);
  plotSurface(tmp);
  
  getMaxPxxMap(tmpI,mdp.Pxax,pi);
  tmpI.reshape(global_maze.d0,global_maze.d1);
  plotMatrixFlow(tmpI,.5);
  plot(wait);
}

#else

void showMaze(){ MT_MSG("display only implemented when compiling with freeglut"); }
void plotPolicyAndValue(const arr& pi,const arr& V,const MDP& mdp,bool wait){}
void glDisplayGrey   (const arr &x,uint d0,uint d1,bool wait,uint win){}
void glDisplayRedBlue(const arr &x,uint d0,uint d1,bool wait,uint win){}

#endif
