#include "mstep.h"

void standardMstep(arr& param,const arr& post,uint left){
  param = post;
  param.tensorCondNormalize(left);
}

void noisyMaxMstep2(arr& param,const arr& likelihood,uint left,double noise){
  // compute a multiplicative update of the parameter from the posterior
  checkNan(param);
  checkNan(likelihood);
  param = likelihood;
  param.tensorCondMax(left);
  if(noise){
    rndUni(param,noise,2.*noise,true);
    param.tensorCondNormalize(left);
  }
}

void noisyMaxMstep(arr& param,const arr& post,uint left){
  // compute a multiplicative update of the parameter from the posterior
  checkNan(param);
  checkNan(post);
  arr factor;
  factor = post;
  factor /= param;
  factor.tensorCondMax(left);
  factor += 3.;
  rndUni(factor,.0,1e-3,true);
  rndUni(param,.0001,.00011,true);
  param *= factor;
  param.tensorCondNormalize(left);
  checkNan(param);
}
